<?php
	/* Tajuk: Ambil Gambar dari server dan Cache kan gambar tersebut di server kita.
	 * 
	 * Code ini membantu untuk mengambil gambar dari Syndetics untuk disimpan di dalam server anda.
	 * Kaedah ini dapat membantu pihak perpustakaan untuk menyimpan Book Cover di dalam server sendiri.
	 * Di dalam keadaan Syndetics tidak berfungsi atau lesen Syendetics sudah tamat. Script ini membantu untuk
	 * melayan Book Cover untuk buku anda dari Cache yang telah kita simpan sebelum ini.
	 *
	 * Adap pun program ini adalah hasil ciptaan Art Zemon, art@zemon.name. Di mana beliau telah menulis script ini untuk dapatkan gambar dari
	 * LibraryThings. Saya Telah olah script ini sesuai dengan kehendak dan kegunaan saya, iaitu mengambil gambar dari Syndetics.
	 * 
	 * Ahmad Munawar MA | mr.munawar@gmail.com
	 * 10-JULY-2010
	 *
	 * Script ini dilesenkan di bawah CC BY-NC 4.0 
	 * Lihat: https://creativecommons.org/licenses/by-nc/4.0/ untuk keterangan lanjut
	 * 
	 * Cara Guna:	 
	 *		Masukkan atau embed elemen berikut didalam OPAC atau mana² applikasi anda seperti berikut:
	 *		<img src="simpan-muka-buku.php?size=MC&isbn=$ISBN" alt="$ISBN>
	 *
	 *
	 * Cara Install:
	 *		1) Upload File "simpan-muka-buku.php" ke dalam server
	 *		2) Create Folder di dalam Server dimana Book Cover akan disimpan.
	 *		3) Pastikan Folder (contoh: muka-buku) itu boleh ditulis oleh PHP (Dalam Serti Kata Lain - setkan Folder Permission kepada 755)
	 *		4) Masukkan nama folder itu (contoh: muka-buku) dibawah. Line 33 dan 37
	 *		5) Pastikan anda mempunyai nama Lesen untuk Syndetics
	 *		6) TestingCode = true jika nak tgk output. Sesuai untuk test². Off Jika sudah ready untuk Live.
	 *		
	 */

	//Masukkan Nama Folder di sini
	define('KEPALA', 'muka-buku');
	// Masukkan Nama Lesen Library	
	define('LESEN', 'RAHSIA-XXXXX-RAHSIA');
	// Ini gambar default jika tak ada Gambar (
	define('GAMBAR-TIADA', 'muka-buku/transparent.gif');
	
	$TestingCode = true;
	
	/*
	 * ================= Ini Rangka Script. Jangan Tukar kalau tak berani =================
	 */
			
	if ($TestingCode)
		header("Content-type: text/html");
	
	// Size - Rujuk Documentation Syndetics  Small Cover: sc.gif / Medium Cover: mc.gif / Large Cover: lc.gif
	$size = strtolower($_REQUEST['size']);	
	if ('sc' != $size && 'mc' != $size && 'lc' != $size)
	{
		print "<p>ERROR - Illegal size. Must be either LC (Small), MC (Medium) or LC (Large). Please refer Syndetics Documentation </p>";
		exit;
	}
	
	// Ini untuk memastikan ISBN hanya berada didalam format yang betul. Buang semua kecuali Angka dan huruf X.
	// Ini bisa membantu sekiranya No ISBN dari sistem tidak sekata contoh 9780415579841/978-0415-5798-41/9780415579841 (e-book)
	// Juga untuk membantu sekiranya ISBN bukan 10 atau 13
	$isbn = strtoupper(preg_replace('/[^0-9Xx]/', '', $_REQUEST['isbn']));
	if (10 != strlen($isbn) && 13 != strlen($isbn))
	{
		print "<p>Error - ISBN must be either 10 or 13 Characters</p>";
		exit;
	}
	
	// Next Step - Script ini akan bikin folder menggunakan No ISBN yang telah diberi (dekat dlm contoh tadi)
	// Boleh refer Function BikinFolder untuk keterangan lanjut
	$directory = BikinFolder(KEPALA, $isbn, $TestingCode);
	
	// Ini nak kasi tahu dekat mana gambar tu ada.
	$GambarMukaBuku = "${directory}/${isbn}-${size}.jpg";
	
	// Display ini jika TestingCode = True
	if ($TestingCode)
		print "<p>Create atau Load Gambar dari Local Server: $GambarMukaBuku</p>\n";
	
	// Jika Image Tiada.
	if ( ! file_exists($GambarMukaBuku) )
	{

	// Kita amik dulu gambar dari Syndetics		
		
		$sourceURL = 'https://secure.syndetics.com/index.aspx?isbn=' . "$isbn" . "/mc.jpg&client=" . LESEN;
		
	// Display ini jika TestingCode = True		
		if ($TestingCode)
			print "<p>Gambar Tiada di server. Jom kita ambil dari Syndetics. Source Gambar: $sourceURL</p>\n";
		
	// Kita	Store Gambar Dalam Folder		
		if ($remote = fopen($sourceURL, 'r') )
		{
			$image = '';
			while ( ! feof($remote) )
				$image .= fread($remote, 8192);
			fclose($remote);
	
			if (strlen($image) >= 100  &&  $local = fopen($GambarMukaBuku, 'w'))
			{
				fwrite($local, $image);
				fclose($local);
				if ($TestingCode)
					print "<p>Berjaya. Gambar dari Syndetics sudah disimpan di dalam server</p>\n";
			}
		}
	}
	else
	{
	// Jika Image ada, amik je terus dari folder yang kita setkan tadi.	
	// Display ini jika TestingCode = True
		if ($TestingCode)
			print "<p>Gambar ini ada di dalam Server. Yeay!</p>\n";
	}
	$GambarKitaSimpan = file_exists($GambarMukaBuku) ? $GambarMukaBuku : GAMBAR-TIADA;
	if ($TestingCode)
	{						
		print "<p>Gambar kita ada simpan disini: ";
		print $_SERVER['SERVER_NAME'] . "/" . basename(getcwd()) ."/" . $GambarKitaSimpan;
		print "</p>\n";
	;
		
	}
	else
	{
		header("Content-Type: image/jpeg");
		header("Content-Length: " . filesize($GambarKitaSimpan));
		header("X-Pad: avoid browser bug");
	}
		
	print "<img class=thumber3 src='{$GambarKitaSimpan}'>";

	
	// Ini kita clusterkan folder berdasarkan ISBN 
	// kalau 13 - 1234567890123 jadi 123/456/789/012/3
	// kalau 10 - 1234567890 jadi 123/456/789/0
	function BikinFolder($KEPALA, $isbn, $TestingCode)
	{
		$parts = Array ($KEPALA, 
			substr($isbn, 0, 3), 
			substr($isbn, 3, 3), 
			substr($isbn, 6, 3), 
			substr($isbn, 9, 3));		
		
		if (13 == strlen($isbn))
			array_push($parts, substr($isbn, 12, 3));
		$dirName = join('/', $parts);
		if (file_exists($dirName))
			return $dirName;
		$path = $KEPALA;
		for ($i = 1; $i < count($parts); $i++)
		{
			$path .= '/' . $parts[$i];
			if ($TestingCode)
				print "<p>Buat Folder di directory: $path</p>\n";
			@mkdir($path);
		}
		return $dirName;
	}
?>